<?php 
/*	
*	Author: CJ Carter
*	Version 1.0 beta 1
*	License: GPLv2 (same as WordPress) http://www.gnu.org/licenses/gpl-2.0.html
*	Description:
*		This file is a "quick and dirty" routine to help administrators
*		moving from a single-site, or several single-site, WordPress installation(s)
*		to a multi-site installation under WordPress 3.0.
*		Its purpose is to update the WP3 user table from the user tables of the
*		sites you import into the database, and then transfer these new user IDs
*		to your imported posts and comments.
*
*		This routine assumes that you have installed WP3.0, have created the new site, imported your
*		previous sites' files after modifying the necessary table names and link URLs (please
*		refer to other sites -- e.g. http://bavatuesdays.com/importing-a-single-wp-blog-to-a-wpmu-installation/)
*		Please remember that you MUST also move over the wp_users table (changing name).
*		Install this routine in your WP3 root directory. Run it from your browser.
*	Disclaimer:
*		This software is "as-is". No warranty or claim is made that it will work correctly for you.
*		DO NOT use this on a site whose database hasn't been backed-up. This routine directly writes to
*		and updates the WordPress database and should be considered a potential threat to the stability
*		of the database as well as the functioning of WordPress itself. You are on your own and assume all the
*		risk of running this software (including, but not exclusively referring to: lost time, productivity,
*		monetary costs, reputation costs, site stability, user or administrative satisfaction, exceeding CPU quotas
*		from your server host [and the consquences thereof], etc.). I have tried to add error-checking where 
*		important, and have tested it with a variety of configurations. Even so, just because it works for me 
*		doesn't mean it will necessarily work for you. Fair warning.
*	History:
*		May 7, 2010: Release 1.0b1
*/
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
	<head>
	<meta http-equiv="content-type" content="text/html; charset=windows-1250" />
	<title>WP-to-WP3 User Convert</title>
	<?php require_once("wp-config.php");
		//connection to the database
		$dbhandle = mysql_connect(DB_HOST, DB_USER, DB_PASSWORD) or die("Couldn't connect to SQL Server on '" . DB_HOST . "'"); 
		//select a database to work with
		$selected = mysql_select_db(DB_NAME, $dbhandle) or die("Couldn't open database '" . DB_NAME . "'"); 
	?>
	</head>
	<body>
	<?php 
		$blognum = $_POST["blog_number"];
		if ($blognum == NULL) {
		// On the first time called, we set up the form listing choices for blogs with user data to process
		// The submitted form will call this file again, but with POST data attached
			$sql = "SELECT blog_id, domain FROM " . $table_prefix . "blogs ORDER BY domain ASC";
// query alpha
			$result = mysql_query($sql) or die("Query 'alpha' failed with error: ".mysql_error());;
			if (!$result) {
				echo "<p>I couldn't find any blogs to process.</p>\n";
				echo "<p>" . mysql_error() . "</p>\n";
				echo "<p>Ending program.</p>\n";
				exit();
			}
			?>
			<form action="userconvert.php" method="post">
				<p>These blogs have user tables associated with them (please select one):</p>
				<?php 
				while ( $row = mysql_fetch_array($result) ) {
					// Test to see if there is a user table
					$users_table = $table_prefix . $row['blog_id'] . "_users";
					$sql = "SELECT 1 FROM `".$users_table."` LIMIT 0"; // this is the low-bandwidth query for the test
// query bravo
					$table_result = mysql_query($sql);
					if ($table_result) {
						// process the row...
						echo('<INPUT type="radio" name="blog_number" value="' . $row['blog_id'] . '">' . $row['domain'] . '<BR />' . "\n");
					}
				}
				?>
				<br />
				<input type="submit" />
			</form>
		<?php 
		} else {
			// Now that we have POST data, we've skipped the form processing and will now process the database.
			// But first, we should set up some useful variables...
			$main_users_table = $table_prefix . "users";
			$main_users_meta = $table_prefix . "usermeta";
			$blog_level = $table_prefix . $blognum . "_";
			$blog_users_table = $blog_level . "users";
			$blog_posts_table = $blog_level . "posts";
			$blog_comments_table = $blog_level . "comments";
			
// 	The user_migrate table exists to keep track of: 
//		user IDs changed during the migrations
//		which blogs is/are attached to the change
//		which items have been processed using this change
//			(this is so items such as posts or comments or other tables that access the user ID
//			 can do their processing at another time or with another program.)
//
			$sql = "CREATE TABLE IF NOT EXISTS `um_user-migrate` ( ";
			$sql .=	"`migrate_id` bigint(20) unsigned NOT NULL auto_increment, ";
			$sql .=	"`main_userID` bigint(20) unsigned NOT NULL default '0', ";
			$sql .=	"`blog_userID` bigint(20) unsigned NOT NULL default '0', ";
			$sql .=	"`blogID` bigint(20) unsigned NOT NULL default '0', ";
			$sql .=	"`tag_processed` text NOT NULL, ";
			$sql .=	"PRIMARY KEY  (`migrate_id`), ";
			$sql .=	"KEY `main_userID` (`main_userID`), ";
			$sql .=	"KEY `blog_userID` (`blog_userID`) ";
			$sql .=	") ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";
			$result = mysql_query($sql) or die("Query 'create user-migrate table' failed with error: ".mysql_error());
			
			$sql = "SELECT * FROM `" . $blog_users_table . "` ORDER BY 'ID' ASC";
// query charlie			
			$result = mysql_query($sql) or die("Query 'charlie' failed with error: ".mysql_error());
			if (!result) {
				echo "<p>I couldn't find any user records to process.</p>\n";
				echo "<p>" . mysql_error() . "</p>\n";
				echo "<p>Ending program.</p>\n";
				exit();
			} 

			// get all rows from blog users who are already in the main users table.
			$sql = "SELECT m.ID, m.user_login, b.ID AS old_ID FROM $main_users_table m, $blog_users_table b ";
			$sql .= "WHERE m.user_login = b.user_login AND m.user_email = b.user_email";
			$u_result = mysql_query($sql) or die("Query failed with error: ".mysql_error());
			
			echo "<p>Processing existing users...</p>\n";
			while ( $u_row = mysql_fetch_array($u_result) ) {
				
				$main_user_ID = $u_row['ID'];
				$blog_user_ID = $u_row['old_ID'];
				
				$sql = "SELECT * FROM `" . "$main_users_meta" . "` ";
				$sql .= "WHERE `user_id` = '" . $main_user_ID . "' ";
				$sql .= "AND '" . $blog_level . "' = LEFT(`meta_key`, LENGTH('" . $blog_level . "'))";
				$a_result = mysql_query($sql) or die("Query 'data in usermeta' failed with error: ".mysql_error());

				if (mysql_num_rows($a_result) == 0) {
				//	Adding usermeta for this blog to table...
					$sql = "INSERT INTO $main_users_meta (umeta_id, user_id, meta_key, meta_value) VALUES ";
					$sql .= "('', $main_user_ID, '" . $blog_level . "capabilities', 'a:1:{s:10:\"subscriber\";s:1:\"1\";}'), ";
					$sql .= "('', $main_user_ID, '" . $blog_level . "user_level', 0), ";
					$sql .= "('', $main_user_ID, '" . $blog_level . "user-settings', 'm6=o&m0=o&m7=o&m9=o&m8=o&m1=o'), ";
					$sql .= "('', $main_user_ID, '" . $blog_level . "user-settings-time', 1272600332); ";
					$a_result = mysql_query($sql) or die("Query 'insert usermeta' failed with error: ".mysql_error());
				}
//				Updating user-migrate table 
				$sql = "SELECT * FROM `um_user-migrate` 
						WHERE '" . $main_user_ID . "' = `main_userID` AND '" . $blognum . "' = `blogID`";
				$a_result = mysql_query($sql) or die ("Query 'existing entry for user' failed with error: " . mysql_error());
				if (mysql_num_rows($a_result) == 0) {
					$sql = "INSERT INTO `um_user-migrate` (`migrate_id`, `main_userID`, `blog_userID`, `blogID`, `tag_processed`) VALUES ";
					$sql .= "('', '" . $main_user_ID . "', '" . $blog_user_ID . "', '" . $blognum . "', '');";
					$a_result = mysql_query($sql) or die("Query 'insert user-migrate' failed with error: ".mysql_error());
				}
//				Done with existing users.
			}

			
			// get all rows from blog users that don't have a login or email match in the main users table.
			$sql = "SELECT * FROM $blog_users_table b WHERE NOT EXISTS ( ";
			$sql .= "SELECT * FROM $main_users_table m WHERE m.user_login = b.user_login AND m.user_email = b.user_email)";
// query delta
			$i_result = mysql_query($sql) or die("Query 'delta' failed with error: ".mysql_error());

			echo "<p>Processing new users...</p>\n";

			while ( $i_row = mysql_fetch_array($i_result) ) {

//				New User being processed:
//				Adding blog users to main user table...
				$sql = "INSERT INTO $main_users_table ";
				$sql .= "(ID, user_login, user_pass, user_nicename, user_email, ";
				$sql .= "user_url, user_registered, user_activation_key, user_status, display_name) VALUES ";
				$sql .=	"( '' , '" . $i_row['user_login'] . "', '" . $i_row['user_pass'] . "', '" . $i_row['user_nicename'] . "', '"
						. $i_row['user_email'] . "', '" . $i_row['user_url'] . "', '" . $i_row['user_registered'] . "', '"
						. $i_row['user_activation_key'] . "', '" . $i_row['user_status'] . "', '" . $i_row['display_name'] . "' 
						)";
				$a_result = mysql_query($sql) or die("Query 'insert user' failed with error: ".mysql_error());
				
				$new_user_ID = mysql_insert_id();
				$old_user_ID = $i_row['ID'];
				
//				Adding generic "cooked" usermeta to table...
//					Note: This sets level at "subscriber"; Administrators will have to be upgraded manually on the site backend
				$sql = "INSERT INTO $main_users_meta (umeta_id, user_id, meta_key, meta_value) VALUES ";
				$sql .= "('', $new_user_ID, 'first_name', ''), ";
				$sql .= "('', $new_user_ID, 'last_name', ''), ";
				$sql .= "('', $new_user_ID, 'nickname', '" . $i_row['user_nicename'] . "'), ";
				$sql .= "('', $new_user_ID, 'description', ''), ";
				$sql .= "('', $new_user_ID, 'rich_editing', true), ";
				$sql .= "('', $new_user_ID, 'comment_shortcuts', false), ";
				$sql .= "('', $new_user_ID, 'admin_color', 'fresh'), ";
				$sql .= "('', $new_user_ID, 'use_ssl', 0), ";
				$sql .= "('', $new_user_ID, 'aim', ''), ";
				$sql .= "('', $new_user_ID, 'yim', ''), ";
				$sql .= "('', $new_user_ID, 'jabber', ''), ";
				$sql .= "('', $new_user_ID, 'source_domain', '" . DOMAIN_CURRENT_SITE . "'), ";
				$sql .= "('', $new_user_ID, 'primary_blog', " . $blognum . "), ";
				$sql .= "('', $new_user_ID, '" . $blog_level . "capabilities', 'a:1:{s:10:\"subscriber\";s:1:\"1\";}'), ";
				$sql .= "('', $new_user_ID, '" . $blog_level . "user_level', 0), ";
				$sql .= "('', $new_user_ID, '" . $blog_level . "user-settings', 'm6=o&m0=o&m7=o&m9=o&m8=o&m1=o'), ";
				$sql .= "('', $new_user_ID, '" . $blog_level . "user-settings-time', 1272600332); ";
				$a_result = mysql_query($sql) or die("Query 'insert usermeta' failed with error: ".mysql_error());

//				Updating user-migrate table
				$sql = "INSERT INTO `um_user-migrate` (`migrate_id`, `main_userID`, `blog_userID`, `blogID`, `tag_processed`) VALUES ";
				$sql .= "('', '" . $new_user_ID . "', '" . $old_user_ID . "', '" . $blognum . "', '');";
				$a_result = mysql_query($sql) or die("Query 'insert user-migrate' failed with error: ".mysql_error());

//				Done with the new users.
			}

//			Get all rows from users that need to be looked at by admin.
			// *** STILL TO DO ***

			echo "<p>Finished processing user names.</p>\n";

//			Updating IDs on comments...
			echo "<p>Updating comments...</p>\n";

			// Create a temporary table to store necessary info to speed things along
			$nowarray = gettimeofday();
			$temp_table = sprintf('cjt_%u%u', $nowarray['usec'], $nowarray['sec']);

			$sql = "CREATE TEMPORARY TABLE " . $temp_table . " ";
			$sql .= "SELECT DISTINCT m.* FROM `um_user-migrate` m, `" . $blog_comments_table . "` c ";
			$sql .= "WHERE m.blogID = '" . $blognum . "' ";
			$sql .= "AND m.blog_userID = c.user_id ";
			$sql .= "AND LOCATE('#comments#', m.tag_processed) = 0;";
			$a_result = mysql_query($sql) or die ("Query 'create temporary table' in comments failed with error: ".mysql_error());
			
			// Update the blog's comments table
			$sql = "UPDATE `" . $blog_comments_table . "` c, `" . $temp_table . "` t ";
			$sql .= "SET c.user_id = t.main_userID ";
			$sql .= "WHERE c.user_id = t.blog_userID;";
			$a_result = mysql_query($sql) or die ("Query 'update comments table' failed with error: ".mysql_error());

			// Update the info in the user-migate table to show comments have been processed
			$sql = "UPDATE `um_user-migrate` m, `" . $temp_table . "` t ";
			$sql .= "SET m.tag_processed = CONCAT(m.tag_processed, '#comments#') ";
			$sql .= "WHERE m.migrate_id = t.migrate_id;";
			$a_result = mysql_query($sql) or die ("Query 'update user-migrate after comments' failed with error: ".mysql_error());

			echo "<p>Finished updating comments.</p>\n";
			
//			Updating author IDs on posts...
			echo "<p>Updating posts...</p>\n";

			// Clear and re-use the temporary table
			$a_result = mysql_query("TRUNCATE `" . $temp_table . "`") or die ("Truncate temp_table failed with error:".mysql_error());

			$sql = "INSERT INTO `" . $temp_table . "` ";
			$sql .= "SELECT DISTINCT m.* FROM `um_user-migrate` m, `" . $blog_posts_table . "` p ";
			$sql .= "WHERE m.blogID = '" . $blognum . "' ";
			$sql .= "AND m.blog_userID = p.post_author ";
			$sql .= "AND LOCATE('#posts#', m.tag_processed) = 0;";
			$a_result = mysql_query($sql) or die ("Query 'insert into temp_table' in comments failed with error: ".mysql_error());

			// Update the blog's posts table
			$sql = "UPDATE `" . $blog_posts_table . "` p, `" . $temp_table . "` t ";
			$sql .= "SET p.post_author = t.main_userID ";
			$sql .= "WHERE p.post_author = t.blog_userID;";
			$a_result = mysql_query($sql) or die ("Query 'update posts table' failed with error: ".mysql_error());

			// Update the info in the user-migrate table to show that posts have been processed
			$sql = "UPDATE `um_user-migrate` m, `" . $temp_table . "` t ";
			$sql .= "SET m.tag_processed = CONCAT(m.tag_processed, '#posts#') ";
			$sql .= "WHERE m.migrate_id = t.migrate_id;";
			$a_result = mysql_query($sql) or die ("Query 'update user-migrate after comments' failed with error: ".mysql_error());
			
			echo "<p>Finished updating posts.</p>\n";
		}
//	And... with any luck, we're done.
	mysql_close($dbhandle);
	echo "<p>The program is finished. Exiting.</p>\n";
	?>
	</body>
</html>
